//	Copyright 2014 Ohtan's Design Corporation

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^                                            		 =
// ===========================================================================
// ---------------------------------------------------------------------------
//	001 2014.05.24				0.01
//	EVK쐬 16F873A AZu[\[X XC8ֈڐA by A.Ohta
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C						 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****

#include	<xc.h>	//	vWFNgݒőIꂽfoCXIɈp܂

	//	***** 錾 *****


	//	*****  *****

#include	"device.h"  //	foCX

// ***************************************************************************
// *	zdl								 *
// ***************************************************************************
/*
	xZT(LM35Z) x@[o
	PIC16F973A CLOCK:EXT 20MHz Vdd = 5.0V

	RA0/AN0:	PIC <-  		from OP AMP LM358's output
	RA1:(`)
	RA2:(`)
	RA3/Vref+:      PIC <-                  4.00V
	RA4:(`)
	RA5:TR4         PIC ->                  to TR4's base input

	RB0:7SegD.P	PIC -> 7Seg(5)  _D.P    LA601XB Anord Common 7Seg-LED
	RB1:7SegDEG3	PIC -> 7Seg(7)  a
	RB2:7SegDEG2	PIC -> 7Seg(6)  b
	RB3:7SegDEG1	PIC -> 7Seg(4)  c
	RB4:7SegDEG4	PIC -> 7Seg(2)  d
	RB5:7SegDEG3	PIC -> 7Seg(1)  e
	RB6:7SegDEG2	PIC -> 7Seg(9)  f
	RB7:7SegDEG1	PIC -> 7Seg(10) g

	RC0:SW1		PIC <- PullUp SW1 Normal High Push Low
	RC1:SW2		PIC <- PullUp SW2 Normal High Push Low
	RC2:SW3		PIC <- PullUp SW3 Normal High Push Low
	RC3:SW4		PIC <- PullUp SW4 Normal High Push Low
	RC4:(`)
	RC5:DISP3_COM	PIC -> 7Seg(8) Common   1ځ@on œ_
	RC6:DISP2_COM	PIC -> 7Seg(8) Common   2ځ@on œ_
	RC7:DISP1_COM	PIC -> 7Seg(8) Common   3ځ@on œ_

*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  ***** 20MHz (EXT20MHz)

	//	*****  ***** PIC 16F873A p
#pragma config BOREN = OFF
#pragma config CPD = OFF
#pragma config DEBUG = OFF
#pragma config WRT = OFF
#pragma config FOSC = HS
#pragma config WDTE = OFF
#pragma config CP = OFF
#pragma config LVP = OFF
#pragma config PWRTE = OFF


// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


//								  76543210
#define	INIT_PORTA_DATA			0b00000000 								//	|[gf[^
#define	INIT_PORTA_DIR			0b00001011 								//	|[go͕

#define	INIT_PORTB_DATA			0b00000000 								//	|[gf[^
#define	INIT_PORTB_DIR			0b00000000 								//	|[go͕

#define	INIT_PORTC_DATA			0b00000000 								//	|[gf[^
#define	INIT_PORTC_DIR			0b00001111 								//	|[go͕


// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

void	DevInit(void);
unsigned int adc(void);

// ***************************************************************************
// ***************************************************************************
// *	{																 *
// ***************************************************************************
// ***************************************************************************


//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****
	//	***** 16F873A pݒ *****

	ADCON1 = 0b00001111;    // ALL Digital I/O



	//	***** 荞݊ *****											//	f[^ZbgɂO荞ݑΉɔďݒ̂ݍs

//						  76543210
	INTCON = 			0b00000000;										//	荞ݐ䃌WX^i荞݋֎~Avj
						//	bit07:GIE		0	Ă̊荞݋֎~					
						//	bit06:PEIE		0	ytF荞݋֎~			gp
						//	bit05:T0IE		0	^C}OI[ot[荞݋֎~		gp
						//	bit04:INTE		0	O荞݋֎~					
						//	bit03:GPIE		0	ėp̓|[gω荞݋֎~		gp
						//	bit02:T0IF		0	^C}OI[ot[荞ݖ		gp
						//	bit01:INTF		0	O荞ݖ					
						//	bit00:GPIF		0	ėp̓|[gω荞ݖ		gp

	//	***** o̓|[g *****											//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

	PORTA = INIT_PORTA_DATA;											//	WX^ݒ
	PORTB = INIT_PORTB_DATA;											//	WX^ݒ
	PORTC = INIT_PORTC_DATA;											//	WX^ݒ

	TRISA  = INIT_PORTA_DIR;											//	PORTAo͕WX^
	TRISB  = INIT_PORTB_DIR;											//  PORTBo͕WX^
	TRISC  = INIT_PORTC_DIR;											//  PORTCo͕WX^
}

//============================================================================
//	A/D ϊ
//----------------------------------------------------------------------------
//	́F	
//	óF	unsigned int 10bitt A/DϊliElj
//----------------------------------------------------------------------------
//	lF	CH0,AN0 ɂā@Vref+@RB3,Vref- Vss A/Dϊ
//============================================================================
unsigned int adc(void){
                        ADCON0 = 0x81;  // Fosc/81,CH0
                        __delay_us(20);
                        GO_DONE = 1;
                        while(GO_DONE);
                        return (ADRESH << 8) + ADRESL;
}
// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2014 Ohtan's Design Corporation

